import { useState } from 'react';
import { a as useSealedState } from '../chunk-459cc222.js';

/**
 * As simple as `React.useState(false)`
 */
function useCheckboxState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _useSealedState = useSealedState(initialState),
      _useSealedState$curre = _useSealedState.currentValue,
      initialCurrentValue = _useSealedState$curre === void 0 ? false : _useSealedState$curre;

  var _React$useState = useState(initialCurrentValue),
      currentValue = _React$useState[0],
      setValue = _React$useState[1];

  return {
    currentValue: currentValue,
    setValue: setValue
  };
}
var keys = ["currentValue", "setValue"];
useCheckboxState.__keys = keys;

export { useCheckboxState };
