import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-459cc222.js';
import '../Hidden/HiddenState.js';
import { useHidden } from '../Hidden/Hidden.js';
import { useDialogState } from './DialogState.js';

function useDialogBackdrop(options, htmlProps) {
  if (options === void 0) {
    options = {};
  }

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useDialogBackdrop", options, htmlProps);
  htmlProps = mergeProps({
    id: undefined,
    role: "presentation",
    style: {
      position: "fixed",
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      zIndex: 998
    }
  }, htmlProps);
  htmlProps = useHidden(options, htmlProps);
  htmlProps = unstable_useProps("useDialogBackdrop", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useHidden.__keys, useDialogState.__keys);
useDialogBackdrop.__keys = keys;
var DialogBackdrop = unstable_createComponent({
  as: "div",
  useHook: useDialogBackdrop
});

export { DialogBackdrop, useDialogBackdrop };
