import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import '../Button/Button.js';
import '../chunk-459cc222.js';
import '../Hidden/HiddenState.js';
import { useDialogState } from './DialogState.js';
import { useHiddenDisclosure } from '../Hidden/HiddenDisclosure.js';

function useDialogDisclosure(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useDialogDisclosure", options, htmlProps);
  htmlProps = mergeProps({
    "aria-haspopup": "dialog"
  }, htmlProps);
  htmlProps = useHiddenDisclosure(options, htmlProps);
  htmlProps = unstable_useProps("useDialogDisclosure", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useHiddenDisclosure.__keys, useDialogState.__keys);
useDialogDisclosure.__keys = keys;
var DialogDisclosure = unstable_createComponent({
  as: "button",
  useHook: useDialogDisclosure
});

export { DialogDisclosure, useDialogDisclosure };
