import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import { useBox } from '../Box/Box.js';
import '../chunk-459cc222.js';
import '../chunk-b4d83ecc.js';
import { unstable_useFormState } from './FormState.js';
import './utils/setAllIn.js';
import './utils/getIn.js';
import './utils/setIn.js';

function unstable_useForm(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useForm", options, htmlProps);
  htmlProps = mergeProps({
    role: "form",
    noValidate: true,
    onSubmit: function onSubmit(event) {
      event.preventDefault();
      options.submit();
    }
  }, htmlProps);
  htmlProps = useBox(options, htmlProps);
  htmlProps = unstable_useProps("useForm", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useBox.__keys, unstable_useFormState.__keys);
unstable_useForm.__keys = keys;
var unstable_Form = unstable_createComponent({
  as: "form",
  useHook: unstable_useForm
});

export { unstable_Form, unstable_useForm };
