import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import { b as _objectSpread } from '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import '../chunk-29332083.js';
import '../chunk-459cc222.js';
import '../Checkbox/CheckboxState.js';
import { useCheckbox } from '../Checkbox/Checkbox.js';
import '../chunk-b4d83ecc.js';
import { unstable_useFormState } from './FormState.js';
import './utils/setAllIn.js';
import { unstable_getIn } from './utils/getIn.js';
import './utils/setIn.js';
import { a as formatInputName } from '../chunk-062e44ee.js';
import { a as getInputId } from '../chunk-e6fae15a.js';
import { a as getLabelId } from '../chunk-48c13397.js';
import { a as shouldShowError, b as getMessageId } from '../chunk-e2383517.js';

function unstable_useFormCheckbox(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useFormCheckbox", options, htmlProps);
  var isBoolean = typeof options.value === "undefined";
  var currentValue = unstable_getIn(options.values, options.name);

  var setValue = function setValue(value) {
    return options.update(options.name, value);
  };

  htmlProps = mergeProps({
    "aria-invalid": shouldShowError(options, options.name),
    name: formatInputName(options.name),
    onBlur: function onBlur() {
      return options.blur(options.name);
    }
  }, isBoolean ? {
    id: getInputId(options.name, options.baseId),
    "aria-describedby": getMessageId(options.name, options.baseId),
    "aria-labelledby": getLabelId(options.name, options.baseId)
  } : {}, htmlProps);
  htmlProps = useCheckbox(_objectSpread({}, options, {
    currentValue: currentValue,
    setValue: setValue
  }), htmlProps);
  htmlProps = unstable_useProps("useFormCheckbox", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useCheckbox.__keys, unstable_useFormState.__keys, ["name", "value"]);
unstable_useFormCheckbox.__keys = keys;
var unstable_FormCheckbox = unstable_createComponent({
  as: "input",
  useHook: unstable_useFormCheckbox
});

export { unstable_FormCheckbox, unstable_useFormCheckbox };
