import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/SystemProvider.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../system/mergeSystem.js';
import '../Box/Box.js';
import '../chunk-459cc222.js';
import '../chunk-b4d83ecc.js';
import { unstable_useFormState } from './FormState.js';
import './utils/setAllIn.js';
import './utils/getIn.js';
import './utils/setIn.js';
import '../chunk-062e44ee.js';
import { a as getInputId } from '../chunk-e6fae15a.js';
import { a as getLabelId } from '../chunk-48c13397.js';
import { b as getMessageId, a as shouldShowError } from '../chunk-e2383517.js';
import { useGroup } from '../Group/Group.js';

function unstable_useFormGroup(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useFormGroup", options, htmlProps);
  htmlProps = mergeProps({
    id: getInputId(options.name, options.baseId),
    "aria-describedby": getMessageId(options.name, options.baseId),
    "aria-labelledby": getLabelId(options.name, options.baseId),
    "aria-invalid": shouldShowError(options, options.name)
  }, htmlProps);
  htmlProps = useGroup(options, htmlProps);
  htmlProps = unstable_useProps("useFormGroup", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useGroup.__keys, unstable_useFormState.__keys, ["name"]);
unstable_useFormGroup.__keys = keys;
var unstable_FormGroup = unstable_createComponent({
  as: "fieldset",
  useHook: unstable_useFormGroup
});

export { unstable_FormGroup, unstable_useFormGroup };
