import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import { useBox } from '../Box/Box.js';
import '../chunk-459cc222.js';
import '../chunk-b4d83ecc.js';
import { unstable_useFormState } from './FormState.js';
import './utils/setAllIn.js';
import { unstable_getIn } from './utils/getIn.js';
import './utils/setIn.js';
import '../chunk-062e44ee.js';
import '../chunk-e6fae15a.js';
import { a as shouldShowError, b as getMessageId } from '../chunk-e2383517.js';

function shouldShowMessage(_ref, name) {
  var touched = _ref.touched,
      messages = _ref.messages;
  return Boolean(unstable_getIn(touched, name) && unstable_getIn(messages, name));
}

function unstable_useFormMessage(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useFormMessage", options, htmlProps);
  var children = shouldShowError(options, options.name) ? unstable_getIn(options.errors, options.name) : undefined;
  children = children || (shouldShowMessage(options, options.name) ? unstable_getIn(options.messages, options.name) : undefined);
  htmlProps = mergeProps({
    role: "alert",
    id: getMessageId(options.name, options.baseId),
    children: children
  }, htmlProps);
  htmlProps = useBox(options, htmlProps);
  htmlProps = unstable_useProps("useFormMessage", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useBox.__keys, unstable_useFormState.__keys, ["name"]);
unstable_useFormMessage.__keys = keys;
var unstable_FormMessage = unstable_createComponent({
  as: "div",
  useHook: unstable_useFormMessage
});

export { unstable_FormMessage, unstable_useFormMessage };
