import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import { useButton } from '../Button/Button.js';
import '../chunk-459cc222.js';
import '../chunk-b4d83ecc.js';
import { unstable_useFormState } from './FormState.js';
import './utils/setAllIn.js';
import './utils/getIn.js';
import './utils/setIn.js';
import '../chunk-062e44ee.js';
import { a as getInputId } from '../chunk-e6fae15a.js';
import { a as getPushButtonId } from '../chunk-019e2d31.js';

function unstable_useFormRemoveButton(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useFormRemoveButton", options, htmlProps);
  htmlProps = mergeProps({
    onClick: function onClick() {
      options.remove(options.name, options.index);
      var inputId = getInputId(options.name, options.baseId);
      if (!inputId) return;
      window.requestAnimationFrame(function () {
        var selector = "[id^=\"" + inputId + "-\"]";
        var inputs = document.querySelectorAll(selector);

        if (inputs.length) {
          var inputsArray = Array.from(inputs);
          var nextIdx = inputsArray.reduce(function (_final, input) {
            var match = input.id.match(new RegExp(inputId + "-([0-9]+)"));
            if (!match) return _final;
            var idx = match[1];

            if (Number(idx) > _final && options.index >= _final) {
              return Number(idx);
            }

            return _final;
          }, 0);
          var nextSelector = "[id^=\"" + inputId + "-" + nextIdx + "\"]";
          var input = document.querySelector(nextSelector);

          if (input) {
            input.focus();
            return;
          }
        }

        var pushButtonId = getPushButtonId(options.name, options.baseId);

        if (pushButtonId) {
          var pushButton = document.getElementById(pushButtonId);

          if (pushButton) {
            pushButton.focus();
          }
        }
      });
    }
  }, htmlProps);
  htmlProps = useButton(options, htmlProps);
  htmlProps = unstable_useProps("useFormRemoveButton", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useButton.__keys, unstable_useFormState.__keys, ["name", "index"]);
unstable_useFormRemoveButton.__keys = keys;
var unstable_FormRemoveButton = unstable_createComponent({
  as: "button",
  useHook: unstable_useFormRemoveButton
});

export { unstable_FormRemoveButton, unstable_useFormRemoveButton };
