import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import { useBox } from '../Box/Box.js';
import '../chunk-459cc222.js';
import { useHiddenState } from './HiddenState.js';

function useHidden(options, htmlProps) {
  if (options === void 0) {
    options = {};
  }

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useHidden", options, htmlProps);
  htmlProps = mergeProps({
    role: "region",
    id: options.unstable_hiddenId,
    hidden: !options.visible,
    "aria-hidden": !options.visible
  }, htmlProps);
  htmlProps = useBox(options, htmlProps);
  htmlProps = unstable_useProps("useHidden", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useBox.__keys, useHiddenState.__keys);
useHidden.__keys = keys;
var Hidden = unstable_createComponent({
  as: "div",
  useHook: useHidden
});

export { Hidden, useHidden };
