import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import { useButton } from '../Button/Button.js';
import '../chunk-459cc222.js';
import { useHiddenState } from './HiddenState.js';

function useHiddenDisclosure(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useHiddenDisclosure", options, htmlProps);
  htmlProps = mergeProps({
    onClick: options.toggle,
    "aria-expanded": Boolean(options.visible),
    "aria-controls": options.unstable_hiddenId
  }, htmlProps);
  htmlProps = useButton(options, htmlProps);
  htmlProps = unstable_useProps("useHiddenDisclosure", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useButton.__keys, useHiddenState.__keys);
useHiddenDisclosure.__keys = keys;
var HiddenDisclosure = unstable_createComponent({
  as: "button",
  useHook: useHiddenDisclosure
});

export { HiddenDisclosure, useHiddenDisclosure };
