import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import { b as _objectSpread } from '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import '../chunk-29332083.js';
import '../chunk-459cc222.js';
import '../Checkbox/CheckboxState.js';
import { useCheckbox } from '../Checkbox/Checkbox.js';
import '../chunk-e555b6ea.js';
import '../Hidden/HiddenState.js';
import '../chunk-b4d83ecc.js';
import '../Dialog/DialogState.js';
import '../Rover/RoverState.js';
import '../Rover/Rover.js';
import 'popper.js';
import '../Popover/PopoverState.js';
import '../chunk-ee62c270.js';
import './MenuState.js';
import { useMenuItem } from './MenuItem.js';

function useMenuItemCheckbox(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useMenuItemCheckbox", options, htmlProps);
  var currentValue = options.unstable_values[options.name];

  var setValue = function setValue(value) {
    return options.unstable_update(options.name, value);
  };

  htmlProps = mergeProps({
    role: "menuitemcheckbox",
    name: options.name
  }, htmlProps);
  htmlProps = useCheckbox(_objectSpread({}, options, {
    currentValue: currentValue,
    setValue: setValue
  }), htmlProps);
  htmlProps = useMenuItem(options, htmlProps);
  htmlProps = unstable_useProps("useMenuItemCheckbox", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useCheckbox.__keys, useMenuItem.__keys, ["name"]);
useMenuItemCheckbox.__keys = keys;
var MenuItemCheckbox = unstable_createComponent({
  as: "button",
  useHook: useMenuItemCheckbox
});

export { MenuItemCheckbox, useMenuItemCheckbox };
