import { useState, useContext, useEffect, useCallback } from 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import '../utils/mergeProps.js';
import { a as _objectWithoutPropertiesLoose, b as _objectSpread } from '../chunk-397c8002.js';
import '../utils/createComponent.js';
import '../system/useToken.js';
import '../system/useProps.js';
import '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import { a as useSealedState } from '../chunk-459cc222.js';
import '../chunk-e555b6ea.js';
import '../Hidden/HiddenState.js';
import '../chunk-b4d83ecc.js';
import '../Dialog/DialogState.js';
import { useRoverState } from '../Rover/RoverState.js';
import '../Rover/Rover.js';
import 'popper.js';
import { usePopoverState } from '../Popover/PopoverState.js';
import { a as MenuContext } from '../chunk-ee62c270.js';

function useMenuState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _useSealedState = useSealedState(initialState),
      _useSealedState$orien = _useSealedState.orientation,
      orientation = _useSealedState$orien === void 0 ? "vertical" : _useSealedState$orien,
      _useSealedState$unsta = _useSealedState.unstable_gutter,
      initialGutter = _useSealedState$unsta === void 0 ? 0 : _useSealedState$unsta,
      _useSealedState$unsta2 = _useSealedState.unstable_values,
      initialValues = _useSealedState$unsta2 === void 0 ? {} : _useSealedState$unsta2,
      sealed = _objectWithoutPropertiesLoose(_useSealedState, ["orientation", "unstable_gutter", "unstable_values"]);

  var _React$useState = useState(initialValues),
      values = _React$useState[0],
      setValues = _React$useState[1];

  var parent = useContext(MenuContext);
  var placement = sealed.placement || (parent && parent.orientation === "vertical" ? "right-start" : "bottom-start");
  var rover = useRoverState(_objectSpread({}, sealed, {
    orientation: orientation
  }));
  var popover = usePopoverState(_objectSpread({}, sealed, {
    placement: placement,
    unstable_gutter: initialGutter
  }));
  useEffect(function () {
    if (!popover.visible) {
      rover.unstable_reset();
    }
  }, [popover.visible]);
  return _objectSpread({}, rover, popover, {
    unstable_values: values,
    unstable_update: useCallback(function (name, value) {
      setValues(function (vals) {
        var _objectSpread2;

        return _objectSpread({}, vals, (_objectSpread2 = {}, _objectSpread2[name] = typeof value === "function" ? value(vals) : value, _objectSpread2));
      });
    }, [])
  });
}
var keys = [].concat(useRoverState.__keys, usePopoverState.__keys, ["unstable_values", "unstable_update"]);
useMenuState.__keys = keys;

export { useMenuState };
