import { createElement } from 'react';
import '../utils/useId.js';
import { unstable_useCreateElement } from '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import { a as _objectWithoutPropertiesLoose, b as _objectSpread } from '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../chunk-29332083.js';
import '../chunk-459cc222.js';
import { a as warning } from '../chunk-e555b6ea.js';
import 'react-dom';
import { Portal } from '../Portal/Portal.js';
import '../Hidden/HiddenState.js';
import '../Hidden/Hidden.js';
import { useDialog } from '../Dialog/Dialog.js';
import 'body-scroll-lock';
import '../chunk-b4d83ecc.js';
import '../Dialog/DialogState.js';
import 'popper.js';
import { usePopoverState } from './PopoverState.js';

function usePopover(_ref, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _ref$modal = _ref.modal,
      modal = _ref$modal === void 0 ? false : _ref$modal,
      options = _objectWithoutPropertiesLoose(_ref, ["modal"]);

  var _options = _objectSpread({
    modal: modal
  }, options);

  _options = unstable_useOptions("usePopover", _options, htmlProps);
  htmlProps = mergeProps({
    ref: _options.unstable_popoverRef,
    style: _options.unstable_popoverStyles
  }, htmlProps);
  htmlProps = useDialog(_options, htmlProps);
  htmlProps = unstable_useProps("usePopover", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useDialog.__keys, usePopoverState.__keys);
usePopover.__keys = keys;
var Popover = unstable_createComponent({
  as: "div",
  useHook: usePopover,
  useCreateElement: function useCreateElement(type, props, children) {
    process.env.NODE_ENV !== "production" ? warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.\nSee https://www.w3.org/TR/wai-aria-practices-1.1/#dialog_roles_states_props", "Popover") : void 0;
    var element = unstable_useCreateElement(type, props, children);

    if (props["aria-modal"]) {
      return createElement(Portal, null, element);
    }

    return element;
  }
});

export { Popover, usePopover };
