import { createElement } from 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import { b as _objectSpread } from '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import { useBox } from '../Box/Box.js';
import '../chunk-459cc222.js';
import '../Hidden/HiddenState.js';
import '../Dialog/DialogState.js';
import 'popper.js';
import { usePopoverState } from './PopoverState.js';

function usePopoverArrow(options, htmlProps) {
  var _objectSpread2;

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("usePopoverArrow", options, htmlProps);

  var _options$placement$sp = options.placement.split("-"),
      placement = _options$placement$sp[0];

  var transformMap = {
    top: "rotateZ(180deg)",
    right: "rotateZ(-90deg)",
    bottom: "rotateZ(360deg)",
    left: "rotateZ(90deg)"
  };
  htmlProps = mergeProps({
    ref: options.unstable_arrowRef,
    style: _objectSpread({}, options.unstable_arrowStyles, (_objectSpread2 = {
      position: "absolute",
      fontSize: "30px",
      width: "1em",
      height: "1em",
      pointerEvents: "none",
      transform: transformMap[placement]
    }, _objectSpread2[placement] = "100%", _objectSpread2)),
    children: createElement("svg", {
      viewBox: "0 0 30 30"
    }, createElement("path", {
      className: "stroke",
      d: "M23.7,27.1L17,19.9C16.5,19.3,15.8,19,15,19s-1.6,0.3-2.1,0.9l-6.6,7.2C5.3,28.1,3.4,29,2,29h26 C26.7,29,24.6,28.1,23.7,27.1z"
    }), createElement("path", {
      className: "fill",
      d: "M23,27.8c1.1,1.2,3.4,2.2,5,2.2h2H0h2c1.7,0,3.9-1,5-2.2l6.6-7.2c0.7-0.8,2-0.8,2.7,0L23,27.8L23,27.8z"
    }))
  }, htmlProps);
  htmlProps = useBox(options, htmlProps);
  htmlProps = unstable_useProps("usePopoverArrow", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useBox.__keys, usePopoverState.__keys);
usePopoverArrow.__keys = keys;
var PopoverArrow = unstable_createComponent({
  as: "div",
  useHook: usePopoverArrow
});

export { PopoverArrow, usePopoverArrow };
