import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import '../Button/Button.js';
import '../chunk-459cc222.js';
import '../Hidden/HiddenState.js';
import '../Dialog/DialogState.js';
import '../Hidden/HiddenDisclosure.js';
import { useDialogDisclosure } from '../Dialog/DialogDisclosure.js';
import 'popper.js';
import { usePopoverState } from './PopoverState.js';

function usePopoverDisclosure(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("usePopoverDisclosure", options, htmlProps);
  htmlProps = mergeProps({
    ref: options.unstable_referenceRef
  }, htmlProps);
  htmlProps = useDialogDisclosure(options, htmlProps);
  htmlProps = unstable_useProps("usePopoverDisclosure", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useDialogDisclosure.__keys, usePopoverState.__keys);
usePopoverDisclosure.__keys = keys;
var PopoverDisclosure = unstable_createComponent({
  as: "button",
  useHook: usePopoverDisclosure
});

export { PopoverDisclosure, usePopoverDisclosure };
