import 'react';
import '../utils/useId.js';
import { unstable_useCreateElement } from '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import { useBox } from '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import '../chunk-459cc222.js';
import { a as warning } from '../chunk-e555b6ea.js';
import '../chunk-b4d83ecc.js';
import '../Rover/RoverState.js';
import '../Rover/Rover.js';
import { useRadioState } from './RadioState.js';

function useRadioGroup(options, htmlProps) {
  if (options === void 0) {
    options = {};
  }

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useRadioGroup", options, htmlProps);
  htmlProps = mergeProps({
    role: "radiogroup"
  }, htmlProps);
  htmlProps = useBox(options, htmlProps);
  htmlProps = unstable_useProps("useRadioGroup", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useBox.__keys, useRadioState.__keys);
useRadioGroup.__keys = keys;
var RadioGroup = unstable_createComponent({
  as: "fieldset",
  useHook: useRadioGroup,
  useCreateElement: function useCreateElement(type, props, children) {
    process.env.NODE_ENV !== "production" ? warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.\nSee https://www.w3.org/TR/wai-aria-practices-1.1/#wai-aria-roles-states-and-properties-15", "RadioGroup") : void 0;
    return unstable_useCreateElement(type, props, children);
  }
});

export { RadioGroup, useRadioGroup };
