import { useState } from 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import '../utils/mergeProps.js';
import { a as _objectWithoutPropertiesLoose, b as _objectSpread } from '../chunk-397c8002.js';
import '../utils/createComponent.js';
import '../system/useToken.js';
import '../system/useProps.js';
import '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import { a as useSealedState } from '../chunk-459cc222.js';
import '../chunk-e555b6ea.js';
import '../chunk-b4d83ecc.js';
import { useRoverState } from '../Rover/RoverState.js';
import '../Rover/Rover.js';

function useRadioState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _useSealedState = useSealedState(initialState),
      initialCurrentValue = _useSealedState.currentValue,
      _useSealedState$unsta = _useSealedState.unstable_loop,
      loop = _useSealedState$unsta === void 0 ? true : _useSealedState$unsta,
      sealed = _objectWithoutPropertiesLoose(_useSealedState, ["currentValue", "unstable_loop"]);

  var _React$useState = useState(initialCurrentValue),
      currentValue = _React$useState[0],
      setValue = _React$useState[1];

  var rover = useRoverState(_objectSpread({}, sealed, {
    unstable_loop: loop
  }));
  return _objectSpread({}, rover, {
    currentValue: currentValue,
    setValue: setValue
  });
}
var keys = [].concat(useRoverState.__keys, ["currentValue", "setValue"]);
useRadioState.__keys = keys;

export { useRadioState };
