import 'react';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import { a as _objectWithoutPropertiesLoose, b as _objectSpread } from '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/SystemProvider.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../system/mergeSystem.js';
import { useBox } from '../Box/Box.js';

function useSeparator(_ref, htmlProps) {
  if (_ref === void 0) {
    _ref = {};
  }

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _ref2 = _ref,
      _ref2$orientation = _ref2.orientation,
      orientation = _ref2$orientation === void 0 ? "vertical" : _ref2$orientation,
      options = _objectWithoutPropertiesLoose(_ref2, ["orientation"]);

  var _options = _objectSpread({
    orientation: orientation
  }, options);

  _options = unstable_useOptions("useSeparator", _options, htmlProps);
  var flipMap = {
    horizontal: "vertical",
    vertical: "horizontal"
  };
  htmlProps = mergeProps({
    role: "separator",
    "aria-orientation": _options.orientation ? flipMap[_options.orientation] : undefined
  }, htmlProps);
  htmlProps = useBox(_options, htmlProps);
  htmlProps = unstable_useProps("useSeparator", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useBox.__keys, ["orientation"]);
useSeparator.__keys = keys;
var Separator = unstable_createComponent({
  as: "hr",
  useHook: useSeparator
});

export { Separator, useSeparator };
