import 'react';
import '../utils/useId.js';
import { unstable_useCreateElement } from '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import { useBox } from '../Box/Box.js';
import '../chunk-459cc222.js';
import { a as warning } from '../chunk-e555b6ea.js';
import '../Rover/RoverState.js';
import { useTabState } from './TabState.js';

function useTabList(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useTabList", options, htmlProps);
  htmlProps = mergeProps({
    role: "tablist",
    "aria-orientation": options.orientation
  }, htmlProps);
  htmlProps = useBox(options, htmlProps);
  htmlProps = unstable_useProps("useTabList", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useBox.__keys, useTabState.__keys);
useTabList.__keys = keys;
var TabList = unstable_createComponent({
  as: "div",
  useHook: useTabList,
  useCreateElement: function useCreateElement(type, props, children) {
    process.env.NODE_ENV !== "production" ? warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.\nSee https://www.w3.org/TR/wai-aria-practices-1.1/#dialog_roles_states_props-20", "TabList") : void 0;
    return unstable_useCreateElement(type, props, children);
  }
});

export { TabList, useTabList };
