import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import { b as _objectSpread } from '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/SystemProvider.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../system/mergeSystem.js';
import '../Box/Box.js';
import '../chunk-459cc222.js';
import '../chunk-e555b6ea.js';
import '../Hidden/HiddenState.js';
import { useHidden } from '../Hidden/Hidden.js';
import '../Rover/RoverState.js';
import { b as getTabPanelId, a as getTabId } from '../chunk-ddf73afb.js';
import { useTabState } from './TabState.js';

function useTabPanel(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _options = _objectSpread({
    visible: options.unstable_selectedId === options.stopId
  }, options);

  _options = unstable_useOptions("useTabPanel", _options, htmlProps);
  htmlProps = mergeProps({
    role: "tabpanel",
    tabIndex: 0,
    id: getTabPanelId(options.stopId, options.unstable_baseId),
    "aria-labelledby": getTabId(options.stopId, options.unstable_baseId)
  }, htmlProps);
  htmlProps = useHidden(_options, htmlProps);
  htmlProps = unstable_useProps("useTabPanel", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useHidden.__keys, useTabState.__keys, ["stopId"]);
useTabPanel.__keys = keys;
var TabPanel = unstable_createComponent({
  as: "div",
  useHook: useTabPanel
});

export { TabPanel, useTabPanel };
