import { useState } from 'react';
import { unstable_useId } from '../utils/useId.js';
import { a as _objectWithoutPropertiesLoose, b as _objectSpread } from '../chunk-397c8002.js';
import { a as useSealedState } from '../chunk-459cc222.js';
import '../chunk-e555b6ea.js';
import { useRoverState } from '../Rover/RoverState.js';

function useTabState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _useSealedState = useSealedState(initialState),
      _useSealedState$unsta = _useSealedState.unstable_baseId,
      baseId = _useSealedState$unsta === void 0 ? unstable_useId("tab-") : _useSealedState$unsta,
      _useSealedState$unsta2 = _useSealedState.unstable_selectedId,
      sealedSelectedId = _useSealedState$unsta2 === void 0 ? null : _useSealedState$unsta2,
      _useSealedState$unsta3 = _useSealedState.unstable_loop,
      loop = _useSealedState$unsta3 === void 0 ? true : _useSealedState$unsta3,
      _useSealedState$unsta4 = _useSealedState.unstable_manual,
      manual = _useSealedState$unsta4 === void 0 ? false : _useSealedState$unsta4,
      sealed = _objectWithoutPropertiesLoose(_useSealedState, ["unstable_baseId", "unstable_selectedId", "unstable_loop", "unstable_manual"]);

  var _React$useState = useState(sealedSelectedId),
      selectedId = _React$useState[0],
      select = _React$useState[1];

  var rover = useRoverState(_objectSpread({
    unstable_loop: loop,
    unstable_currentId: selectedId
  }, sealed));
  return _objectSpread({}, rover, {
    unstable_baseId: baseId,
    unstable_selectedId: selectedId,
    unstable_manual: manual,
    unstable_select: select
  });
}
var keys = [].concat(useRoverState.__keys, ["unstable_baseId", "unstable_selectedId", "unstable_select", "unstable_manual"]);
useTabState.__keys = keys;

export { useTabState };
