import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-988837cf.js';
import '../chunk-56719312.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import { useBox } from '../Box/Box.js';
import '../chunk-459cc222.js';
import '../Hidden/HiddenState.js';
import '../Dialog/DialogState.js';
import 'popper.js';
import '../Popover/PopoverState.js';
import { useTooltipState } from './TooltipState.js';

function useTooltipReference(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useTooltipReference", options, htmlProps);
  htmlProps = mergeProps({
    ref: options.unstable_referenceRef,
    tabIndex: 0,
    onFocus: options.show,
    onBlur: options.hide,
    onMouseEnter: options.show,
    onMouseLeave: options.hide,
    "aria-describedby": options.unstable_hiddenId
  }, htmlProps);
  htmlProps = useBox(options, htmlProps);
  htmlProps = unstable_useProps("useTooltipReference", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useBox.__keys, useTooltipState.__keys);
useTooltipReference.__keys = keys;
var TooltipReference = unstable_createComponent({
  as: "div",
  useHook: useTooltipReference
});

export { TooltipReference, useTooltipReference };
