var isProduction = process.env.NODE_ENV === "production";
var warnings = [];
function warning(condition, message, label) {
  if (!isProduction) {
    if (!condition) return;
    var finalLabel = label ? "[reakit/" + label + "]\n" : "";
    var text = "" + finalLabel + message;

    if (warnings.indexOf(text) === -1) {
      // TODO: Replace by https://github.com/facebook/react/pull/15170
      // eslint-disable-next-line no-console
      console.warn(text);
      warnings.push(text);
    } // Throwing an error and catching it immediately to improve debugging
    // A consumer can use 'pause on caught exceptions'
    // https://github.com/facebook/react/issues/4216


    try {
      throw Error(text);
    } catch (x) {// do nothing
    }
  }
}

export { warning as a };
