import { a as reduceObjects } from '../chunk-988837cf.js';
import { a as isObject } from '../chunk-56719312.js';

function mergeFunctionsInObjects(objects) {
  var object = reduceObjects(objects, function (value) {
    return typeof value === "function";
  });
  var keys = Object.keys(object);
  var result = {};

  for (var _i = 0, _keys = keys; _i < _keys.length; _i++) {
    var key = _keys[_i];
    var fns = object[key];
    result[key] = fns.length === 1 ? fns[0] : fns.reduce(function (lastHook, currHook) {
      return function () {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return currHook.apply(void 0, args.slice(0, -1).concat([lastHook.apply(void 0, args)]));
      };
    });
  }

  return result;
}

function mergeObjectsInObjects(systems) {
  var object = reduceObjects(systems, isObject);
  var keys = Object.keys(object);
  var result = {};

  for (var _i2 = 0, _keys2 = keys; _i2 < _keys2.length; _i2++) {
    var key = _keys2[_i2];
    var values = object[key];
    result[key] = Object.assign.apply(Object, [{}].concat(values));
  }

  return result;
}

function unstable_mergeSystem() {
  for (var _len2 = arguments.length, systems = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    systems[_key2] = arguments[_key2];
  }

  return Object.assign.apply(Object, [{}].concat(systems, [mergeObjectsInObjects(systems), mergeFunctionsInObjects(systems)]));
}

export { unstable_mergeSystem };
