import { useContext, createElement } from 'react';
import { unstable_SystemContext } from '../system/SystemContext.js';

function isRenderProp(children) {
  return typeof children === "function";
}

var unstable_useCreateElement = function unstable_useCreateElement(type, props, children) {
  if (children === void 0) {
    children = props.children;
  }

  var context = useContext(unstable_SystemContext);

  if (context.useCreateElement) {
    return context.useCreateElement(type, props, children);
  }

  if (isRenderProp(children)) {
    return children(props);
  }

  return createElement(type, props, children);
};

export { unstable_useCreateElement };
