'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
var Tabbable = require('../Tabbable/Tabbable.js');
var __chunk_5 = require('../chunk-d4f443f9.js');
require('../chunk-eb7a57a2.js');
var CheckboxState = require('./CheckboxState.js');

function useCheckbox(options, htmlProps) {
  if (options === void 0) {
    options = {};
  }

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useCheckbox", options, htmlProps);
  var ref = React.useRef(null);
  var isBoolean = typeof options.value === "undefined";
  var checked = typeof options.checked !== "undefined" ? options.checked : isBoolean ? Boolean(options.currentValue) : (options.currentValue || []).indexOf(options.value) !== -1;
  React.useEffect(function () {
    if (ref.current && options.currentValue === "indeterminate") {
      ref.current.indeterminate = true;
    }
  }, [options.currentValue]);
  htmlProps = mergeProps.mergeProps({
    ref: ref,
    checked: checked,
    "aria-checked": options.currentValue === "indeterminate" ? "mixed" : checked,
    value: options.value,
    role: "checkbox",
    type: "checkbox",
    onClick: function onClick(event) {
      if (event.target instanceof HTMLInputElement) return;
      htmlProps.onChange(event);
    },
    onChange: function onChange() {
      if (options.disabled || !options.setValue) return;

      if (isBoolean) {
        options.setValue(!checked);
      } else {
        var array = Array.isArray(options.currentValue) ? options.currentValue : [];
        var index = array.indexOf(options.value);

        if (index === -1) {
          options.setValue([].concat(array, [options.value]));
        } else {
          options.setValue(__chunk_5.removeIndexFromArray(array, index));
        }
      }
    }
  }, htmlProps);
  htmlProps = Tabbable.useTabbable(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useCheckbox", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Tabbable.useTabbable.__keys, CheckboxState.useCheckboxState.__keys, ["value", "checked"]);
useCheckbox.__keys = keys;
var Checkbox = createComponent.unstable_createComponent({
  as: "input",
  useHook: useCheckbox
});

exports.Checkbox = Checkbox;
exports.useCheckbox = useCheckbox;
