'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../Button/Button.js');
require('../chunk-eb7a57a2.js');
require('../Hidden/HiddenState.js');
var DialogState = require('./DialogState.js');
var HiddenDisclosure = require('../Hidden/HiddenDisclosure.js');

function useDialogDisclosure(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useDialogDisclosure", options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    "aria-haspopup": "dialog"
  }, htmlProps);
  htmlProps = HiddenDisclosure.useHiddenDisclosure(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useDialogDisclosure", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(HiddenDisclosure.useHiddenDisclosure.__keys, DialogState.useDialogState.__keys);
useDialogDisclosure.__keys = keys;
var DialogDisclosure = createComponent.unstable_createComponent({
  as: "button",
  useHook: useDialogDisclosure
});

exports.DialogDisclosure = DialogDisclosure;
exports.useDialogDisclosure = useDialogDisclosure;
