'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/SystemProvider.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../system/mergeSystem.js');
var Box = require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../chunk-5a603fe6.js');
var FormState = require('./FormState.js');
require('./utils/setAllIn.js');
var getIn = require('./utils/getIn.js');
require('./utils/setIn.js');
var __chunk_9 = require('../chunk-0ecca8fe.js');
require('../chunk-46c7f4d8.js');
require('../chunk-044cfb41.js');
require('../chunk-acd59aa4.js');
require('../Group/Group.js');
require('./FormGroup.js');
require('../Rover/RoverState.js');
require('../Rover/Rover.js');
require('../Radio/RadioState.js');
var Radio = require('../Radio/Radio.js');
var FormRadioGroup = require('./FormRadioGroup.js');

function unstable_useFormRadio(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useFormRadio", options, htmlProps);
  var rover = React.useContext(FormRadioGroup.FormRadioGroupContext);

  if (!rover) {
    // TODO: Better error
    throw new Error("Missing FormRadioGroup");
  }

  var currentChecked = getIn.unstable_getIn(options.values, options.name);
  var checked = currentChecked === options.value;

  var allOptions = __chunk_3._objectSpread({}, rover, options, {
    checked: checked
  });

  htmlProps = mergeProps.mergeProps({
    name: __chunk_9.formatInputName(options.name),
    onChange: function onChange() {
      return options.update(options.name, options.value);
    },
    onBlur: function onBlur() {
      return options.blur(options.name);
    },
    onFocus: function onFocus() {
      return options.update(options.name, options.value);
    }
  }, htmlProps);
  htmlProps = Radio.useRadio(allOptions, htmlProps);
  htmlProps = useProps.unstable_useProps("useFormRadio", allOptions, htmlProps);
  return htmlProps;
}
var keys = [].concat(Box.useBox.__keys, FormState.unstable_useFormState.__keys, ["name", "value"]);
unstable_useFormRadio.__keys = keys;
var unstable_FormRadio = createComponent.unstable_createComponent({
  as: "input",
  useHook: unstable_useFormRadio
});

exports.unstable_FormRadio = unstable_FormRadio;
exports.unstable_useFormRadio = unstable_useFormRadio;
