'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useId.js');
var useCreateElement = require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/SystemProvider.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../system/mergeSystem.js');
require('../Box/Box.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../chunk-5a603fe6.js');
var FormState = require('./FormState.js');
require('./utils/setAllIn.js');
require('./utils/getIn.js');
require('./utils/setIn.js');
require('../chunk-0ecca8fe.js');
require('../chunk-46c7f4d8.js');
require('../chunk-044cfb41.js');
require('../chunk-acd59aa4.js');
require('../Group/Group.js');
var FormGroup = require('./FormGroup.js');
var RoverState = require('../Rover/RoverState.js');

var FormRadioGroupContext = React.createContext(null);
function unstable_useFormRadioGroup(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useFormRadioGroup", options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    role: "radiogroup"
  }, htmlProps);
  htmlProps = FormGroup.unstable_useFormGroup(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useFormRadioGroup", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(FormGroup.unstable_useFormGroup.__keys, FormState.unstable_useFormState.__keys, ["name"]);
unstable_useFormRadioGroup.__keys = keys;
var unstable_FormRadioGroup = createComponent.unstable_createComponent({
  as: "fieldset",
  useHook: unstable_useFormRadioGroup,
  useCreateElement: function useCreateElement$1(type, props, children) {
    var element = useCreateElement.unstable_useCreateElement(type, props, children);
    var rover = RoverState.useRoverState({
      unstable_loop: true
    });
    var value = React.useMemo(function () {
      return rover;
    }, [rover.unstable_stops, rover.unstable_currentId, rover.unstable_pastId]);
    return React.createElement(FormRadioGroupContext.Provider, {
      value: value
    }, element);
  }
});

exports.FormRadioGroupContext = FormRadioGroupContext;
exports.unstable_FormRadioGroup = unstable_FormRadioGroup;
exports.unstable_useFormRadioGroup = unstable_useFormRadioGroup;
