'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
var Button = require('../Button/Button.js');
require('../chunk-eb7a57a2.js');
require('../chunk-5a603fe6.js');
var FormState = require('./FormState.js');
require('./utils/setAllIn.js');
require('./utils/getIn.js');
require('./utils/setIn.js');

function getFirstInvalidInput(baseId) {
  var selector = "[aria-invalid=true][id^=" + baseId + "]";
  return document.querySelector(selector);
}

function unstable_useFormSubmitButton(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useFormSubmitButton", options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    type: "submit",
    disabled: options.submitting,
    onClick: function onClick() {
      window.requestAnimationFrame(function () {
        var input = getFirstInvalidInput(options.baseId);

        if (input) {
          input.select();
          input.focus();
        }
      });
    }
  }, htmlProps);
  htmlProps = Button.useButton(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useFormSubmitButton", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Button.useButton.__keys, FormState.unstable_useFormState.__keys);
unstable_useFormSubmitButton.__keys = keys;
var unstable_FormSubmitButton = createComponent.unstable_createComponent({
  as: "button",
  useHook: unstable_useFormSubmitButton
});

exports.unstable_FormSubmitButton = unstable_FormSubmitButton;
exports.unstable_useFormSubmitButton = unstable_useFormSubmitButton;
