'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
var Box = require('../Box/Box.js');
require('../chunk-eb7a57a2.js');
var HiddenState = require('./HiddenState.js');

function useHidden(options, htmlProps) {
  if (options === void 0) {
    options = {};
  }

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useHidden", options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    role: "region",
    id: options.unstable_hiddenId,
    hidden: !options.visible,
    "aria-hidden": !options.visible
  }, htmlProps);
  htmlProps = Box.useBox(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useHidden", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Box.useBox.__keys, HiddenState.useHiddenState.__keys);
useHidden.__keys = keys;
var Hidden = createComponent.unstable_createComponent({
  as: "div",
  useHook: useHidden
});

exports.Hidden = Hidden;
exports.useHidden = useHidden;
