'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
var Button = require('../Button/Button.js');
require('../chunk-eb7a57a2.js');
var HiddenState = require('./HiddenState.js');

function useHiddenDisclosure(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useHiddenDisclosure", options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    onClick: options.toggle,
    "aria-expanded": Boolean(options.visible),
    "aria-controls": options.unstable_hiddenId
  }, htmlProps);
  htmlProps = Button.useButton(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useHiddenDisclosure", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Button.useButton.__keys, HiddenState.useHiddenState.__keys);
useHiddenDisclosure.__keys = keys;
var HiddenDisclosure = createComponent.unstable_createComponent({
  as: "button",
  useHook: useHiddenDisclosure
});

exports.HiddenDisclosure = HiddenDisclosure;
exports.useHiddenDisclosure = useHiddenDisclosure;
