'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var useId = require('../utils/useId.js');
var __chunk_6 = require('../chunk-eb7a57a2.js');

function useHiddenState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _useSealedState = __chunk_6.useSealedState(initialState),
      _useSealedState$unsta = _useSealedState.unstable_hiddenId,
      hiddenId = _useSealedState$unsta === void 0 ? useId.unstable_useId("hidden-") : _useSealedState$unsta,
      _useSealedState$visib = _useSealedState.visible,
      sealedVisible = _useSealedState$visib === void 0 ? false : _useSealedState$visib;

  var _React$useState = React.useState(sealedVisible),
      visible = _React$useState[0],
      setVisible = _React$useState[1];

  var show = React.useCallback(function () {
    return setVisible(true);
  }, []);
  var hide = React.useCallback(function () {
    return setVisible(false);
  }, []);
  var toggle = React.useCallback(function () {
    return setVisible(function (v) {
      return !v;
    });
  }, []);
  return {
    unstable_hiddenId: hiddenId,
    visible: visible,
    show: show,
    hide: hide,
    toggle: toggle
  };
}
var keys = ["unstable_hiddenId", "visible", "show", "hide", "toggle"];
useHiddenState.__keys = keys;

exports.useHiddenState = useHiddenState;
