'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useId.js');
var useCreateElement = require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-d4f443f9.js');
require('../chunk-eb7a57a2.js');
var __chunk_7 = require('../chunk-ebc3ed80.js');
require('react-dom');
require('../Portal/Portal.js');
require('../Hidden/HiddenState.js');
require('../Hidden/Hidden.js');
require('../Dialog/Dialog.js');
require('body-scroll-lock');
require('../chunk-5a603fe6.js');
require('../Dialog/DialogState.js');
require('../Rover/RoverState.js');
require('../Rover/Rover.js');
require('popper.js');
require('../Popover/PopoverState.js');
var Popover = require('../Popover/Popover.js');
var StaticMenu = require('./StaticMenu.js');
var __chunk_14 = require('../chunk-8a7a2ea8.js');
var MenuState = require('./MenuState.js');

function useMenu(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var parent = React.useContext(__chunk_14.MenuContext);
  var parentIsHorizontal = parent && parent.orientation === "horizontal";

  var _options = __chunk_3._objectSpread({
    unstable_autoFocusOnShow: !parent,
    unstable_autoFocusOnHide: !parentIsHorizontal
  }, options, {
    modal: false,
    // We'll handle esc differently
    hideOnEsc: false
  });

  _options = useOptions.unstable_useOptions("useMenu", _options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    role: "menu",
    onKeyDown: function onKeyDown(event) {
      if (event.key === "Escape" && _options.hide) {
        // Only stop propagtion if there's no parent menu
        // Otherwise, pressing Esc should close all menus
        if (!parent) {
          event.stopPropagation();
        }

        _options.hide();
      }
    }
  }, htmlProps);
  htmlProps = StaticMenu.useStaticMenu(_options, htmlProps);
  htmlProps = Popover.usePopover(_options, htmlProps);
  htmlProps = useProps.unstable_useProps("useMenu", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Popover.usePopover.__keys, StaticMenu.useStaticMenu.__keys, MenuState.useMenuState.__keys);
useMenu.__keys = keys;
var Menu = createComponent.unstable_createComponent({
  as: "div",
  useHook: useMenu,
  useCreateElement: function useCreateElement$1(type, props, children) {
    process.env.NODE_ENV !== "production" ? __chunk_7.warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.\nSee https://www.w3.org/TR/wai-aria-practices-1.1/#wai-aria-roles-states-and-properties-13", "Menu") : void 0;
    return useCreateElement.unstable_useCreateElement(type, props, children);
  }
});

exports.Menu = Menu;
exports.useMenu = useMenu;
