'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../Button/Button.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../Hidden/HiddenState.js');
require('../chunk-5a603fe6.js');
require('../Dialog/DialogState.js');
require('../Hidden/HiddenDisclosure.js');
require('../Dialog/DialogDisclosure.js');
require('../Rover/RoverState.js');
require('../Rover/Rover.js');
require('popper.js');
require('../Popover/PopoverState.js');
var __chunk_14 = require('../chunk-8a7a2ea8.js');
var MenuState = require('./MenuState.js');
var PopoverDisclosure = require('../Popover/PopoverDisclosure.js');

function useMenuDisclosure(options, _ref) {
  if (_ref === void 0) {
    _ref = {};
  }

  var _ref2 = _ref,
      _onKeyDown = _ref2.onKeyDown,
      htmlProps = __chunk_3._objectWithoutPropertiesLoose(_ref2, ["onKeyDown"]);

  var parent = React.useContext(__chunk_14.MenuContext);
  var ref = React.useRef(null);
  options = useOptions.unstable_useOptions("useMenuDisclosure", options, htmlProps);
  var dir = options.placement ? options.placement.split("-")[0] : undefined;
  htmlProps = mergeProps.mergeProps({
    ref: ref,
    "aria-haspopup": "menu",
    onFocus: function onFocus() {
      if (parent && parent.orientation === "horizontal") {
        options.show();
      }
    },
    onMouseOver: function onMouseOver() {
      if (!parent || !options.placement) return;
      var parentIsHorizontal = parent.orientation === "horizontal";

      if (!parentIsHorizontal) {
        setTimeout(function () {
          if (ref.current && ref.current.contains(document.activeElement)) {
            options.show();
            ref.current.focus();
          }
        }, 200);
      } else if (ref.current) {
        var parentMenu = ref.current.closest("[role=menu],[role=menubar]");
        var subjacentOpenMenu = parentMenu && parentMenu.querySelector("[role=menu][aria-hidden=false]");

        if (subjacentOpenMenu) {
          ref.current.focus();
        }
      }
    },
    onKeyDown: function onKeyDown(event) {
      var keyMap = {
        Escape: options.hide,
        Enter: parent && options.unstable_first,
        " ": parent && options.unstable_first,
        ArrowUp: dir === "top" || dir === "bottom" ? options.unstable_last : false,
        ArrowRight: dir === "right" && options.unstable_first,
        ArrowDown: dir === "bottom" || dir === "top" ? options.unstable_first : false,
        ArrowLeft: dir === "left" && options.unstable_first
      };

      if (event.key in keyMap) {
        var key = event.key;
        var action = keyMap[key];

        if (typeof action === "function") {
          event.preventDefault();
          options.show();
          action(); // Prevent onKeyDown from being called twice for the same keys.

          return;
        }
      }

      if (_onKeyDown) {
        _onKeyDown(event);
      }
    }
  }, htmlProps);
  htmlProps = PopoverDisclosure.usePopoverDisclosure(__chunk_3._objectSpread({}, options, {
    toggle: parent ? options.show : options.toggle
  }), htmlProps);
  htmlProps = useProps.unstable_useProps("useMenuDisclosure", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(PopoverDisclosure.usePopoverDisclosure.__keys, MenuState.useMenuState.__keys);
useMenuDisclosure.__keys = keys;
var MenuDisclosure = createComponent.unstable_createComponent({
  as: "button",
  useHook: useMenuDisclosure
});

exports.MenuDisclosure = MenuDisclosure;
exports.useMenuDisclosure = useMenuDisclosure;
