'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
var Box = require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../Hidden/HiddenState.js');
require('../chunk-5a603fe6.js');
require('../Dialog/DialogState.js');
require('../Rover/RoverState.js');
require('../Rover/Rover.js');
require('popper.js');
require('../Popover/PopoverState.js');
require('../chunk-8a7a2ea8.js');
var MenuState = require('./MenuState.js');

function useMenuGroup(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useMenuGroup", options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    role: "group"
  }, htmlProps);
  htmlProps = Box.useBox(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useMenuGroup", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Box.useBox.__keys, MenuState.useMenuState.__keys);
useMenuGroup.__keys = keys;
var MenuGroup = createComponent.unstable_createComponent({
  as: "fieldset",
  useHook: useMenuGroup
});

exports.MenuGroup = MenuGroup;
exports.useMenuGroup = useMenuGroup;
