'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../Hidden/HiddenState.js');
require('../chunk-5a603fe6.js');
require('../Dialog/DialogState.js');
require('../Rover/RoverState.js');
var Rover = require('../Rover/Rover.js');
require('popper.js');
require('../Popover/PopoverState.js');
var __chunk_14 = require('../chunk-8a7a2ea8.js');
var MenuState = require('./MenuState.js');

function useMenuItem(options, _ref) {
  if (_ref === void 0) {
    _ref = {};
  }

  var _ref2 = _ref,
      children = _ref2.children,
      _onKeyDown = _ref2.onKeyDown,
      htmlProps = __chunk_3._objectWithoutPropertiesLoose(_ref2, ["children", "onKeyDown"]);

  var parent = React.useContext(__chunk_14.MenuContext);
  var ref = React.useRef(null);
  options = useOptions.unstable_useOptions("useMenuItem", options, htmlProps);
  var providerValue = React.useMemo(function () {
    return {
      orientation: options.orientation,
      unstable_next: options.unstable_next,
      unstable_previous: options.unstable_previous,
      parent: parent
    };
  }, [options.orientation, options.unstable_next, options.unstable_previous, parent]);
  htmlProps = mergeProps.mergeProps({
    ref: ref,
    role: "menuitem",
    onMouseOver: function onMouseOver() {
      if (options.orientation !== "horizontal" && ref.current) {
        ref.current.focus();
      }
    },
    onKeyDown: function onKeyDown(event) {
      var _options = options,
          hide = _options.hide,
          placement = _options.placement;
      if (!parent || !hide || !placement) return;
      var horizontalParent = parent;

      while (horizontalParent && horizontalParent.orientation !== "horizontal") {
        horizontalParent = horizontalParent.parent;
      }

      var _placement$split = placement.split("-"),
          dir = _placement$split[0];

      var keyMap = {
        ArrowRight: horizontalParent && dir !== "left" ? function () {
          hide();
          horizontalParent.unstable_next();
        } : dir === "left" && hide,
        ArrowLeft: horizontalParent && dir !== "right" ? function () {
          hide();
          horizontalParent.unstable_previous();
        } : dir === "right" && hide
      };

      if (event.key in keyMap) {
        var key = event.key;
        var action = keyMap[key];

        if (typeof action === "function") {
          event.preventDefault();
          action(); // Prevent onKeyDown from being called twice for the same keys.

          return;
        }
      }

      if (_onKeyDown) {
        _onKeyDown(event);
      }
    }
  }, htmlProps);
  htmlProps = Rover.useRover(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useMenuItem", options, htmlProps);
  return __chunk_3._objectSpread({}, htmlProps, {
    children: typeof children === "function" ? function (props) {
      return React.createElement(__chunk_14.MenuContext.Provider, {
        value: providerValue
      }, children(props));
    } : children
  });
}
var keys = [].concat(Rover.useRover.__keys, MenuState.useMenuState.__keys);
useMenuItem.__keys = keys;
var MenuItem = createComponent.unstable_createComponent({
  as: "button",
  useHook: useMenuItem
});

exports.MenuItem = MenuItem;
exports.useMenuItem = useMenuItem;
