'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../Hidden/HiddenState.js');
require('../chunk-5a603fe6.js');
require('../Dialog/DialogState.js');
require('../Rover/RoverState.js');
require('../Rover/Rover.js');
require('../Radio/RadioState.js');
var Radio = require('../Radio/Radio.js');
require('popper.js');
require('../Popover/PopoverState.js');
require('../chunk-8a7a2ea8.js');
require('./MenuState.js');
var MenuItem = require('./MenuItem.js');

function useMenuItemRadio(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useMenuItemRadio", options, htmlProps);
  var currentValue = options.unstable_values[options.name];

  var setValue = function setValue(value) {
    return options.unstable_update(options.name, value);
  };

  htmlProps = mergeProps.mergeProps({
    role: "menuitemradio"
  }, htmlProps);
  htmlProps = Radio.useRadio(__chunk_3._objectSpread({}, options, {
    currentValue: currentValue,
    setValue: setValue
  }), htmlProps);
  htmlProps = MenuItem.useMenuItem(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useMenuItemRadio", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Radio.useRadio.__keys, MenuItem.useMenuItem.__keys, ["name"]);
useMenuItemRadio.__keys = keys;
var MenuItemRadio = createComponent.unstable_createComponent({
  as: "button",
  useHook: useMenuItemRadio
});

exports.MenuItemRadio = MenuItemRadio;
exports.useMenuItemRadio = useMenuItemRadio;
