'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useId.js');
var useCreateElement = require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../chunk-d4f443f9.js');
require('../chunk-eb7a57a2.js');
var __chunk_7 = require('../chunk-ebc3ed80.js');
require('react-dom');
var Portal = require('../Portal/Portal.js');
require('../Hidden/HiddenState.js');
require('../Hidden/Hidden.js');
var Dialog = require('../Dialog/Dialog.js');
require('body-scroll-lock');
require('../chunk-5a603fe6.js');
require('../Dialog/DialogState.js');
require('popper.js');
var PopoverState = require('./PopoverState.js');

function usePopover(_ref, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _ref$modal = _ref.modal,
      modal = _ref$modal === void 0 ? false : _ref$modal,
      options = __chunk_3._objectWithoutPropertiesLoose(_ref, ["modal"]);

  var _options = __chunk_3._objectSpread({
    modal: modal
  }, options);

  _options = useOptions.unstable_useOptions("usePopover", _options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    ref: _options.unstable_popoverRef,
    style: _options.unstable_popoverStyles
  }, htmlProps);
  htmlProps = Dialog.useDialog(_options, htmlProps);
  htmlProps = useProps.unstable_useProps("usePopover", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Dialog.useDialog.__keys, PopoverState.usePopoverState.__keys);
usePopover.__keys = keys;
var Popover = createComponent.unstable_createComponent({
  as: "div",
  useHook: usePopover,
  useCreateElement: function useCreateElement$1(type, props, children) {
    process.env.NODE_ENV !== "production" ? __chunk_7.warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.\nSee https://www.w3.org/TR/wai-aria-practices-1.1/#dialog_roles_states_props", "Popover") : void 0;
    var element = useCreateElement.unstable_useCreateElement(type, props, children);

    if (props["aria-modal"]) {
      return React.createElement(Portal.Portal, null, element);
    }

    return element;
  }
});

exports.Popover = Popover;
exports.usePopover = usePopover;
