'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
var Box = require('../Box/Box.js');
require('../chunk-eb7a57a2.js');
require('../Hidden/HiddenState.js');
require('../Dialog/DialogState.js');
require('popper.js');
var PopoverState = require('./PopoverState.js');

function usePopoverArrow(options, htmlProps) {
  var _objectSpread2;

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("usePopoverArrow", options, htmlProps);

  var _options$placement$sp = options.placement.split("-"),
      placement = _options$placement$sp[0];

  var transformMap = {
    top: "rotateZ(180deg)",
    right: "rotateZ(-90deg)",
    bottom: "rotateZ(360deg)",
    left: "rotateZ(90deg)"
  };
  htmlProps = mergeProps.mergeProps({
    ref: options.unstable_arrowRef,
    style: __chunk_3._objectSpread({}, options.unstable_arrowStyles, (_objectSpread2 = {
      position: "absolute",
      fontSize: "30px",
      width: "1em",
      height: "1em",
      pointerEvents: "none",
      transform: transformMap[placement]
    }, _objectSpread2[placement] = "100%", _objectSpread2)),
    children: React.createElement("svg", {
      viewBox: "0 0 30 30"
    }, React.createElement("path", {
      className: "stroke",
      d: "M23.7,27.1L17,19.9C16.5,19.3,15.8,19,15,19s-1.6,0.3-2.1,0.9l-6.6,7.2C5.3,28.1,3.4,29,2,29h26 C26.7,29,24.6,28.1,23.7,27.1z"
    }), React.createElement("path", {
      className: "fill",
      d: "M23,27.8c1.1,1.2,3.4,2.2,5,2.2h2H0h2c1.7,0,3.9-1,5-2.2l6.6-7.2c0.7-0.8,2-0.8,2.7,0L23,27.8L23,27.8z"
    }))
  }, htmlProps);
  htmlProps = Box.useBox(options, htmlProps);
  htmlProps = useProps.unstable_useProps("usePopoverArrow", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Box.useBox.__keys, PopoverState.usePopoverState.__keys);
usePopoverArrow.__keys = keys;
var PopoverArrow = createComponent.unstable_createComponent({
  as: "div",
  useHook: usePopoverArrow
});

exports.PopoverArrow = PopoverArrow;
exports.usePopoverArrow = usePopoverArrow;
