'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../Button/Button.js');
require('../chunk-eb7a57a2.js');
require('../Hidden/HiddenState.js');
require('../Dialog/DialogState.js');
require('../Hidden/HiddenDisclosure.js');
var DialogDisclosure = require('../Dialog/DialogDisclosure.js');
require('popper.js');
var PopoverState = require('./PopoverState.js');

function usePopoverDisclosure(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("usePopoverDisclosure", options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    ref: options.unstable_referenceRef
  }, htmlProps);
  htmlProps = DialogDisclosure.useDialogDisclosure(options, htmlProps);
  htmlProps = useProps.unstable_useProps("usePopoverDisclosure", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(DialogDisclosure.useDialogDisclosure.__keys, PopoverState.usePopoverState.__keys);
usePopoverDisclosure.__keys = keys;
var PopoverDisclosure = createComponent.unstable_createComponent({
  as: "button",
  useHook: usePopoverDisclosure
});

exports.PopoverDisclosure = PopoverDisclosure;
exports.usePopoverDisclosure = usePopoverDisclosure;
