'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../chunk-5a603fe6.js');
require('../Rover/RoverState.js');
var Rover = require('../Rover/Rover.js');
var RadioState = require('./RadioState.js');

function useRadio(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useRadio", options, htmlProps);
  var checked = typeof options.checked !== "undefined" ? options.checked : options.currentValue === options.value;
  htmlProps = mergeProps.mergeProps({
    checked: checked,
    "aria-checked": checked,
    value: options.value,
    role: "radio",
    type: "radio",
    onClick: function onClick(event) {
      if (event.target instanceof HTMLInputElement) return;
      htmlProps.onChange(event);
    },
    onChange: function onChange() {
      if (options.disabled || !options.setValue) return;
      options.setValue(options.value);
    }
  }, htmlProps);
  htmlProps = Rover.useRover(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useRadio", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Rover.useRover.__keys, RadioState.useRadioState.__keys, ["value", "checked"]);
useRadio.__keys = keys;
var Radio = createComponent.unstable_createComponent({
  as: "input",
  useHook: useRadio
});

exports.Radio = Radio;
exports.useRadio = useRadio;
