'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
var useCreateElement = require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
var Box = require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-eb7a57a2.js');
var __chunk_7 = require('../chunk-ebc3ed80.js');
require('../chunk-5a603fe6.js');
require('../Rover/RoverState.js');
require('../Rover/Rover.js');
var RadioState = require('./RadioState.js');

function useRadioGroup(options, htmlProps) {
  if (options === void 0) {
    options = {};
  }

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useRadioGroup", options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    role: "radiogroup"
  }, htmlProps);
  htmlProps = Box.useBox(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useRadioGroup", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Box.useBox.__keys, RadioState.useRadioState.__keys);
useRadioGroup.__keys = keys;
var RadioGroup = createComponent.unstable_createComponent({
  as: "fieldset",
  useHook: useRadioGroup,
  useCreateElement: function useCreateElement$1(type, props, children) {
    process.env.NODE_ENV !== "production" ? __chunk_7.warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.\nSee https://www.w3.org/TR/wai-aria-practices-1.1/#wai-aria-roles-states-and-properties-15", "RadioGroup") : void 0;
    return useCreateElement.unstable_useCreateElement(type, props, children);
  }
});

exports.RadioGroup = RadioGroup;
exports.useRadioGroup = useRadioGroup;
