'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
require('../utils/createComponent.js');
require('../system/useToken.js');
require('../system/useProps.js');
require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
var __chunk_6 = require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../chunk-5a603fe6.js');
var RoverState = require('../Rover/RoverState.js');
require('../Rover/Rover.js');

function useRadioState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _useSealedState = __chunk_6.useSealedState(initialState),
      initialCurrentValue = _useSealedState.currentValue,
      _useSealedState$unsta = _useSealedState.unstable_loop,
      loop = _useSealedState$unsta === void 0 ? true : _useSealedState$unsta,
      sealed = __chunk_3._objectWithoutPropertiesLoose(_useSealedState, ["currentValue", "unstable_loop"]);

  var _React$useState = React.useState(initialCurrentValue),
      currentValue = _React$useState[0],
      setValue = _React$useState[1];

  var rover = RoverState.useRoverState(__chunk_3._objectSpread({}, sealed, {
    unstable_loop: loop
  }));
  return __chunk_3._objectSpread({}, rover, {
    currentValue: currentValue,
    setValue: setValue
  });
}
var keys = [].concat(RoverState.useRoverState.__keys, ["currentValue", "setValue"]);
useRadioState.__keys = keys;

exports.useRadioState = useRadioState;
