'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var useId = require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
var Tabbable = require('../Tabbable/Tabbable.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
var __chunk_8 = require('../chunk-5a603fe6.js');
var RoverState = require('./RoverState.js');

function useRover(options, _ref) {
  if (_ref === void 0) {
    _ref = {};
  }

  var _ref2 = _ref,
      tabIndex = _ref2.tabIndex,
      _onKeyDown = _ref2.onKeyDown,
      htmlProps = __chunk_3._objectWithoutPropertiesLoose(_ref2, ["tabIndex", "onKeyDown"]);

  options = useOptions.unstable_useOptions("useRover", options, htmlProps);
  var ref = React.useRef(null);
  var id = useId.unstable_useId("rover-");
  var stopId = options.stopId || htmlProps.id || id;
  var reallyDisabled = options.disabled && !options.unstable_focusable;
  var noFocused = options.unstable_currentId == null;
  var focused = options.unstable_currentId === stopId;
  var isFirst = options.unstable_stops[0] && options.unstable_stops[0].id === stopId;
  var shouldTabIndex = focused || isFirst && noFocused;
  React.useEffect(function () {
    if (reallyDisabled) return undefined;
    options.unstable_register(stopId, ref);
    return function () {
      return options.unstable_unregister(stopId);
    };
  }, [stopId, reallyDisabled, options.unstable_register, options.unstable_unregister]);
  __chunk_8.useUpdateEffect(function () {
    if (ref.current && focused) {
      ref.current.focus();
    }
  }, [focused]);
  htmlProps = mergeProps.mergeProps({
    ref: ref,
    id: stopId,
    tabIndex: shouldTabIndex ? tabIndex : -1,
    onFocus: function onFocus() {
      return options.unstable_move(stopId);
    },
    onKeyDown: function onKeyDown(event) {
      var _options = options,
          orientation = _options.orientation;
      var keyMap = {
        ArrowUp: orientation !== "horizontal" && options.unstable_previous,
        ArrowRight: orientation !== "vertical" && options.unstable_next,
        ArrowDown: orientation !== "horizontal" && options.unstable_next,
        ArrowLeft: orientation !== "vertical" && options.unstable_previous,
        Home: options.unstable_first,
        End: options.unstable_last,
        PageUp: options.unstable_first,
        PageDown: options.unstable_last
      };

      if (event.key in keyMap) {
        var key = event.key;
        var action = keyMap[key];

        if (action) {
          event.preventDefault();
          action(); // Prevent onKeyDown from being called twice for the same keys.

          return;
        }
      }

      if (_onKeyDown) {
        _onKeyDown(event);
      }
    }
  }, htmlProps);
  htmlProps = Tabbable.useTabbable(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useRover", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Tabbable.useTabbable.__keys, RoverState.useRoverState.__keys, ["stopId"]);
useRover.__keys = keys;
var Rover = createComponent.unstable_createComponent({
  as: "button",
  useHook: useRover
});

exports.Rover = Rover;
exports.useRover = useRover;
