'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/SystemProvider.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../system/mergeSystem.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../chunk-5a603fe6.js');
require('../Rover/RoverState.js');
var Rover = require('../Rover/Rover.js');
var __chunk_15 = require('../chunk-8078ee09.js');
var TabState = require('./TabState.js');

function useTab(_ref, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _ref$unstable_focusab = _ref.unstable_focusable,
      unstable_focusable = _ref$unstable_focusab === void 0 ? true : _ref$unstable_focusab,
      options = __chunk_3._objectWithoutPropertiesLoose(_ref, ["unstable_focusable"]);

  var _options = __chunk_3._objectSpread({
    unstable_focusable: unstable_focusable
  }, options);

  _options = useOptions.unstable_useOptions("useTab", _options, htmlProps);
  var selected = _options.unstable_selectedId === _options.stopId;
  htmlProps = mergeProps.mergeProps({
    role: "tab",
    id: __chunk_15.getTabId(_options.stopId, _options.unstable_baseId),
    "aria-selected": selected,
    "aria-controls": __chunk_15.getTabPanelId(_options.stopId, _options.unstable_baseId),
    onClick: function onClick() {
      if (!_options.disabled && !selected) {
        _options.unstable_select(_options.stopId);
      }
    },
    onFocus: function onFocus() {
      if (!_options.disabled && !_options.unstable_manual && !selected) {
        _options.unstable_select(_options.stopId);
      }
    }
  }, htmlProps);
  htmlProps = Rover.useRover(_options, htmlProps);
  htmlProps = useProps.unstable_useProps("useTab", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Rover.useRover.__keys, TabState.useTabState.__keys, ["stopId"]);
useTab.__keys = keys;
var Tab = createComponent.unstable_createComponent({
  as: "button",
  useHook: useTab
});

exports.Tab = Tab;
exports.useTab = useTab;
