'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/SystemProvider.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../system/mergeSystem.js');
require('../Box/Box.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../Hidden/HiddenState.js');
var Hidden = require('../Hidden/Hidden.js');
require('../Rover/RoverState.js');
var __chunk_15 = require('../chunk-8078ee09.js');
var TabState = require('./TabState.js');

function useTabPanel(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _options = __chunk_3._objectSpread({
    visible: options.unstable_selectedId === options.stopId
  }, options);

  _options = useOptions.unstable_useOptions("useTabPanel", _options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    role: "tabpanel",
    tabIndex: 0,
    id: __chunk_15.getTabPanelId(options.stopId, options.unstable_baseId),
    "aria-labelledby": __chunk_15.getTabId(options.stopId, options.unstable_baseId)
  }, htmlProps);
  htmlProps = Hidden.useHidden(_options, htmlProps);
  htmlProps = useProps.unstable_useProps("useTabPanel", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Hidden.useHidden.__keys, TabState.useTabState.__keys, ["stopId"]);
useTabPanel.__keys = keys;
var TabPanel = createComponent.unstable_createComponent({
  as: "div",
  useHook: useTabPanel
});

exports.TabPanel = TabPanel;
exports.useTabPanel = useTabPanel;
