'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var useId = require('../utils/useId.js');
var __chunk_3 = require('../chunk-37dea005.js');
var __chunk_6 = require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
var RoverState = require('../Rover/RoverState.js');

function useTabState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _useSealedState = __chunk_6.useSealedState(initialState),
      _useSealedState$unsta = _useSealedState.unstable_baseId,
      baseId = _useSealedState$unsta === void 0 ? useId.unstable_useId("tab-") : _useSealedState$unsta,
      _useSealedState$unsta2 = _useSealedState.unstable_selectedId,
      sealedSelectedId = _useSealedState$unsta2 === void 0 ? null : _useSealedState$unsta2,
      _useSealedState$unsta3 = _useSealedState.unstable_loop,
      loop = _useSealedState$unsta3 === void 0 ? true : _useSealedState$unsta3,
      _useSealedState$unsta4 = _useSealedState.unstable_manual,
      manual = _useSealedState$unsta4 === void 0 ? false : _useSealedState$unsta4,
      sealed = __chunk_3._objectWithoutPropertiesLoose(_useSealedState, ["unstable_baseId", "unstable_selectedId", "unstable_loop", "unstable_manual"]);

  var _React$useState = React.useState(sealedSelectedId),
      selectedId = _React$useState[0],
      select = _React$useState[1];

  var rover = RoverState.useRoverState(__chunk_3._objectSpread({
    unstable_loop: loop,
    unstable_currentId: selectedId
  }, sealed));
  return __chunk_3._objectSpread({}, rover, {
    unstable_baseId: baseId,
    unstable_selectedId: selectedId,
    unstable_manual: manual,
    unstable_select: select
  });
}
var keys = [].concat(RoverState.useRoverState.__keys, ["unstable_baseId", "unstable_selectedId", "unstable_select", "unstable_manual"]);
useTabState.__keys = keys;

exports.useTabState = useTabState;
