'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_3 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
var Box = require('../Box/Box.js');
var __chunk_4 = require('../chunk-9263130a.js');

function isNativeTabbable(element) {
  if (element instanceof HTMLButtonElement) return true;
  if (element instanceof HTMLInputElement) return true;
  if (element instanceof HTMLSelectElement) return true;
  if (element instanceof HTMLTextAreaElement) return true;
  if (element instanceof HTMLAnchorElement) return true;
  if (element instanceof HTMLAudioElement) return true;
  if (element instanceof HTMLVideoElement) return true;
  return false;
}

function useTabbable(_ref2, _ref) {
  if (_ref2 === void 0) {
    _ref2 = {};
  }

  if (_ref === void 0) {
    _ref = {};
  }

  var _ref3 = _ref2,
      _ref3$unstable_clickK = _ref3.unstable_clickKeys,
      unstable_clickKeys = _ref3$unstable_clickK === void 0 ? [" "] : _ref3$unstable_clickK,
      options = __chunk_3._objectWithoutPropertiesLoose(_ref3, ["unstable_clickKeys"]);

  var _ref4 = _ref,
      _ref4$tabIndex = _ref4.tabIndex,
      tabIndex = _ref4$tabIndex === void 0 ? 0 : _ref4$tabIndex,
      _onClick = _ref4.onClick,
      _onMouseOver = _ref4.onMouseOver,
      disabled = _ref4.disabled,
      htmlProps = __chunk_3._objectWithoutPropertiesLoose(_ref4, ["tabIndex", "onClick", "onMouseOver", "disabled"]);

  var _options = __chunk_3._objectSpread({
    unstable_clickKeys: unstable_clickKeys,
    disabled: disabled
  }, options);

  _options = useOptions.unstable_useOptions("useTabbable", _options, htmlProps);
  var clickKeysRef = __chunk_4.useLiveRef(_options.unstable_clickKeys);
  var reallyDisabled = _options.disabled && !_options.unstable_focusable;
  htmlProps = mergeProps.mergeProps({
    disabled: reallyDisabled,
    tabIndex: reallyDisabled ? undefined : tabIndex,
    "aria-disabled": _options.disabled,
    onClick: function onClick(event) {
      if (_options.disabled) {
        event.stopPropagation();
        event.preventDefault();
      } else if (_onClick) {
        _onClick(event);
      }
    },
    onMouseOver: function onMouseOver(event) {
      if (_options.disabled) {
        event.stopPropagation();
        event.preventDefault();
      } else if (_onMouseOver) {
        _onMouseOver(event);
      }
    },
    onKeyDown: function onKeyDown(event) {
      if (isNativeTabbable(event.target) || _options.disabled) return;

      if (clickKeysRef.current && clickKeysRef.current.indexOf(event.key) !== -1) {
        event.preventDefault();
        event.target.dispatchEvent(new MouseEvent("click", {
          view: window,
          bubbles: true,
          cancelable: false
        }));
      }
    }
  }, htmlProps);
  htmlProps = Box.useBox(_options, htmlProps);
  htmlProps = useProps.unstable_useProps("useTabbable", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Box.useBox.__keys, ["disabled", "unstable_focusable", "unstable_clickKeys"]);
useTabbable.__keys = keys;
var Tabbable = createComponent.unstable_createComponent({
  as: "button",
  useHook: useTabbable
});

exports.Tabbable = Tabbable;
exports.useTabbable = useTabbable;
