'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
var useCreateElement = require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
var Box = require('../Box/Box.js');
require('../chunk-eb7a57a2.js');
var __chunk_7 = require('../chunk-ebc3ed80.js');
require('../Rover/RoverState.js');
var ToolbarState = require('./ToolbarState.js');

function useToolbar(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useToolbar", options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    role: "toolbar",
    "aria-orientation": options.orientation
  }, htmlProps);
  htmlProps = Box.useBox(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useToolbar", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Box.useBox.__keys, ToolbarState.useToolbarState.__keys);
useToolbar.__keys = keys;
var Toolbar = createComponent.unstable_createComponent({
  as: "div",
  useHook: useToolbar,
  useCreateElement: function useCreateElement$1(type, props, children) {
    process.env.NODE_ENV !== "production" ? __chunk_7.warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.\nSee https://www.w3.org/TR/wai-aria-practices-1.1/#dialog_roles_states_props-21", "Toolbar") : void 0;
    return useCreateElement.unstable_useCreateElement(type, props, children);
  }
});

exports.Toolbar = Toolbar;
exports.useToolbar = useToolbar;
