'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-8e8e1bad.js');
require('../chunk-2138b837.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
var Box = require('../Box/Box.js');
require('../chunk-eb7a57a2.js');
require('../Hidden/HiddenState.js');
require('../Dialog/DialogState.js');
require('popper.js');
require('../Popover/PopoverState.js');
var TooltipState = require('./TooltipState.js');

function useTooltipReference(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useTooltipReference", options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    ref: options.unstable_referenceRef,
    tabIndex: 0,
    onFocus: options.show,
    onBlur: options.hide,
    onMouseEnter: options.show,
    onMouseLeave: options.hide,
    "aria-describedby": options.unstable_hiddenId
  }, htmlProps);
  htmlProps = Box.useBox(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useTooltipReference", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Box.useBox.__keys, TooltipState.useTooltipState.__keys);
useTooltipReference.__keys = keys;
var TooltipReference = createComponent.unstable_createComponent({
  as: "div",
  useHook: useTooltipReference
});

exports.TooltipReference = TooltipReference;
exports.useTooltipReference = useTooltipReference;
