'use strict';

/**
 * Transforms [{ a: "a" }, { a: "b" }] into { a: ["a", "b"] }
 */
function reduceObjects(objects, filter) {
  var result = {};

  for (var _iterator = objects, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
    var _ref;

    if (_isArray) {
      if (_i >= _iterator.length) break;
      _ref = _iterator[_i++];
    } else {
      _i = _iterator.next();
      if (_i.done) break;
      _ref = _i.value;
    }

    var object = _ref;
    var keys = Object.keys(object);

    for (var _i2 = 0, _keys = keys; _i2 < _keys.length; _i2++) {
      var _key = _keys[_i2];
      // eslint-disable-next-line no-continue
      if (filter && !filter(object[_key], _key)) continue;
      result[_key] = [].concat(result[_key] || [], [object[_key]]);
    }
  }

  return result;
}

exports.reduceObjects = reduceObjects;
