'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var __chunk_1 = require('../chunk-8e8e1bad.js');
var __chunk_2 = require('../chunk-2138b837.js');

function mergeFunctionsInObjects(objects) {
  var object = __chunk_1.reduceObjects(objects, function (value) {
    return typeof value === "function";
  });
  var keys = Object.keys(object);
  var result = {};

  for (var _i = 0, _keys = keys; _i < _keys.length; _i++) {
    var key = _keys[_i];
    var fns = object[key];
    result[key] = fns.length === 1 ? fns[0] : fns.reduce(function (lastHook, currHook) {
      return function () {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return currHook.apply(void 0, args.slice(0, -1).concat([lastHook.apply(void 0, args)]));
      };
    });
  }

  return result;
}

function mergeObjectsInObjects(systems) {
  var object = __chunk_1.reduceObjects(systems, __chunk_2.isObject);
  var keys = Object.keys(object);
  var result = {};

  for (var _i2 = 0, _keys2 = keys; _i2 < _keys2.length; _i2++) {
    var key = _keys2[_i2];
    var values = object[key];
    result[key] = Object.assign.apply(Object, [{}].concat(values));
  }

  return result;
}

function unstable_mergeSystem() {
  for (var _len2 = arguments.length, systems = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    systems[_key2] = arguments[_key2];
  }

  return Object.assign.apply(Object, [{}].concat(systems, [mergeObjectsInObjects(systems), mergeFunctionsInObjects(systems)]));
}

exports.unstable_mergeSystem = unstable_mergeSystem;
