'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var useCreateElement = require('./useCreateElement.js');
require('../system/SystemContext.js');
var __chunk_3 = require('../chunk-37dea005.js');

function forwardRef(component) {
  return React.forwardRef(component);
}

function splitProps(props, keys) {
  var propsKeys = Object.keys(props);
  var picked = {};
  var omitted = {};

  for (var _i = 0, _propsKeys = propsKeys; _i < _propsKeys.length; _i++) {
    var key = _propsKeys[_i];

    if (keys.indexOf(key) >= 0) {
      picked[key] = props[key];
    } else {
      omitted[key] = props[key];
    }
  }

  return [picked, omitted];
}

function unstable_createComponent(_ref) {
  var type = _ref.as,
      useHook = _ref.useHook,
      _ref$keys = _ref.keys,
      keys = _ref$keys === void 0 ? useHook && useHook.__keys || [] : _ref$keys,
      _ref$useCreateElement = _ref.useCreateElement,
      useCreateElement$1 = _ref$useCreateElement === void 0 ? useCreateElement.unstable_useCreateElement : _ref$useCreateElement;

  var Comp = function Comp(_ref2, ref) {
    var _ref2$as = _ref2.as,
        as = _ref2$as === void 0 ? type : _ref2$as,
        props = __chunk_3._objectWithoutPropertiesLoose(_ref2, ["as"]);

    if (useHook) {
      var _splitProps = splitProps(props, keys),
          _options = _splitProps[0],
          htmlProps = _splitProps[1];

      var elementProps = useHook(_options, __chunk_3._objectSpread({
        ref: ref
      }, htmlProps));
      return useCreateElement$1(as, elementProps || {});
    }

    return useCreateElement$1(as, props);
  };

  if (process.env.NODE_ENV !== "production" && useHook) {
    Comp.displayName = useHook.name.replace(/^(unstable_)?use/, "");
  }

  return forwardRef(Comp);
}

exports.unstable_createComponent = unstable_createComponent;
