'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var SystemContext = require('../system/SystemContext.js');

function isRenderProp(children) {
  return typeof children === "function";
}

var unstable_useCreateElement = function unstable_useCreateElement(type, props, children) {
  if (children === void 0) {
    children = props.children;
  }

  var context = React.useContext(SystemContext.unstable_SystemContext);

  if (context.useCreateElement) {
    return context.useCreateElement(type, props, children);
  }

  if (isRenderProp(children)) {
    return children(props);
  }

  return React.createElement(type, props, children);
};

exports.unstable_useCreateElement = unstable_useCreateElement;
