import * as React from "react";
import { TabbableOptions, TabbableProps } from "../Tabbable/Tabbable";
import { CheckboxStateReturn } from "./CheckboxState";
export declare type CheckboxOptions = TabbableOptions & Partial<CheckboxStateReturn> & {
    /**
     * Checkbox's value is going to be used when multiple checkboxes share the
     * same state. Checking a checkbox with value will add it to the state
     * array.
     */
    value?: any;
    /**
     * Checkbox's checked state. If present, it's used instead of currentValue.
     */
    checked?: boolean;
};
export declare type CheckboxProps = TabbableProps & React.InputHTMLAttributes<any>;
export declare function useCheckbox(options?: CheckboxOptions, htmlProps?: CheckboxProps): import("..").RadioProps;
export declare namespace useCheckbox {
    var __keys: ("unstable_system" | "disabled" | "unstable_focusable" | "unstable_clickKeys" | "value" | "currentValue" | "setValue" | "checked")[];
}
export declare const Checkbox: <TT extends React.ElementType<any> = "input">({ as, ...props }: import("../__utils/types").PropsWithAs<CheckboxOptions, TT>, ref: React.Ref<any>) => JSX.Element;
