import * as React from "react";
import { SealedInitialState } from "../__utils/useSealedState";
export declare type CheckboxState = {
    /**
     * Stores the state of the checkbox.
     * If checkboxes that share this state have defined a `value` prop, it's
     * going to be an array.
     * @default false
     */
    currentValue: boolean | "indeterminate" | any[];
};
export declare type CheckboxActions = {
    /**
     * Sets `currentValue`.
     */
    setValue: React.Dispatch<React.SetStateAction<CheckboxState["currentValue"]>>;
};
export declare type CheckboxInitialState = Partial<Pick<CheckboxState, "currentValue">>;
export declare type CheckboxStateReturn = CheckboxState & CheckboxActions;
/**
 * As simple as `React.useState(false)`
 */
export declare function useCheckboxState(initialState?: SealedInitialState<CheckboxInitialState>): CheckboxStateReturn;
export declare namespace useCheckboxState {
    var __keys: ("currentValue" | "setValue")[];
}
