import * as React from "react";
import { GroupOptions, GroupProps } from "../Group/Group";
import { PropsWithAs } from "../__utils/types";
import { DeepPath } from "./__utils/types";
import { unstable_FormStateReturn } from "./FormState";
export declare type unstable_FormGroupOptions<V, P extends DeepPath<V, P>> = GroupOptions & Partial<unstable_FormStateReturn<V>> & Pick<unstable_FormStateReturn<V>, "baseId" | "touched" | "errors"> & {
    /** TODO: Description */
    name: P;
};
export declare type unstable_FormGroupProps = GroupProps & React.FieldsetHTMLAttributes<any>;
export declare function unstable_useFormGroup<V, P extends DeepPath<V, P>>(options: unstable_FormGroupOptions<V, P>, htmlProps?: unstable_FormGroupProps): import("..").RadioGroupProps;
export declare namespace unstable_useFormGroup {
    var __keys: ("unstable_system" | "push" | "values" | "remove" | "blur" | "submit" | "name" | "reset" | "baseId" | "touched" | "messages" | "errors" | "validating" | "valid" | "submitting" | "submitSucceed" | "submitFailed" | "validate" | "update")[];
}
export declare const unstable_FormGroup: <V, P extends DeepPath<V, P>, T extends React.ElementType<any> = "fieldset">(props: PropsWithAs<unstable_FormGroupOptions<V, P>, T>) => JSX.Element;
