/// <reference types="react" />
import { BoxOptions, BoxProps } from "../Box/Box";
import { PropsWithAs } from "../__utils/types";
import { unstable_FormStateReturn } from "./FormState";
import { DeepPath } from "./__utils/types";
export declare type unstable_FormMessageOptions<V, P extends DeepPath<V, P>> = BoxOptions & Partial<unstable_FormStateReturn<V>> & Pick<unstable_FormStateReturn<V>, "baseId" | "touched" | "errors" | "messages"> & {
    /** TODO: Description */
    name: P;
};
export declare type unstable_FormMessageProps = BoxProps;
export declare function unstable_useFormMessage<V, P extends DeepPath<V, P>>(options: unstable_FormMessageOptions<V, P>, htmlProps?: unstable_FormMessageProps): import("react").HTMLAttributes<any> & import("react").RefAttributes<any>;
export declare namespace unstable_useFormMessage {
    var __keys: ("unstable_system" | "push" | "values" | "remove" | "blur" | "submit" | "name" | "reset" | "baseId" | "touched" | "messages" | "errors" | "validating" | "valid" | "submitting" | "submitSucceed" | "submitFailed" | "validate" | "update")[];
}
export declare const unstable_FormMessage: <V, P extends DeepPath<V, P>, T extends import("react").ElementType<any> = "div">(props: PropsWithAs<unstable_FormMessageOptions<V, P>, T>) => JSX.Element;
