/// <reference types="react" />
import { ButtonOptions, ButtonProps } from "../Button/Button";
import { ArrayValue, PropsWithAs } from "../__utils/types";
import { unstable_FormStateReturn } from "./FormState";
import { DeepPath, DeepPathValue } from "./__utils/types";
export declare type unstable_FormPushButtonOptions<V, P extends DeepPath<V, P>> = ButtonOptions & Partial<unstable_FormStateReturn<V>> & Pick<unstable_FormStateReturn<V>, "baseId" | "values" | "push"> & {
    /** TODO: Description */
    name: P;
    /** TODO: Description */
    value: ArrayValue<DeepPathValue<V, P>>;
};
export declare type unstable_FormPushButtonProps = ButtonProps;
export declare function unstable_useFormPushButton<V, P extends DeepPath<V, P>>(options: unstable_FormPushButtonOptions<V, P>, htmlProps?: unstable_FormPushButtonProps): ButtonProps;
export declare namespace unstable_useFormPushButton {
    var __keys: ("unstable_system" | "push" | "values" | "remove" | "blur" | "disabled" | "unstable_focusable" | "unstable_clickKeys" | "submit" | "name" | "value" | "reset" | "baseId" | "touched" | "messages" | "errors" | "validating" | "valid" | "submitting" | "submitSucceed" | "submitFailed" | "validate" | "update")[];
}
export declare const unstable_FormPushButton: <V, P extends DeepPath<V, P>, T extends import("react").ElementType<any> = "button">(props: PropsWithAs<unstable_FormPushButtonOptions<V, P>, T>) => JSX.Element;
