import { ArrayValue } from "../__utils/types";
import { SealedInitialState } from "../__utils/useSealedState";
import { DeepPartial, DeepMap, DeepPath, DeepPathValue } from "./__utils/types";
declare type Messages<V> = DeepPartial<DeepMap<V, string | null | void>>;
declare type ValidateReturn<V> = Promise<Messages<V> | null | void> | Messages<V> | null | void;
interface Update<V> {
    <P extends DeepPath<V, P>>(name: P, value: DeepPathValue<V, P>): void;
    <P extends DeepPath<V, P>>(name: P, value: (value: DeepPathValue<V, P>) => DeepPathValue<V, P>): void;
}
export declare type unstable_FormState<V> = {
    /** TODO: Description */
    baseId: string;
    /** TODO: Description */
    values: V;
    /** TODO: Description */
    touched: DeepPartial<DeepMap<V, boolean>>;
    /** TODO: Description */
    messages: Messages<V>;
    /** TODO: Description */
    errors: Messages<V>;
    /** TODO: Description */
    validating: boolean;
    /** TODO: Description */
    valid: boolean;
    /** TODO: Description */
    submitting: boolean;
    /** TODO: Description */
    submitSucceed: number;
    /** TODO: Description */
    submitFailed: number;
};
export declare type unstable_FormActions<V> = {
    /** TODO: Description */
    reset: () => void;
    /** TODO: Description */
    validate: (values?: V) => ValidateReturn<V>;
    /** TODO: Description */
    submit: () => void;
    /** TODO: Description */
    update: Update<V>;
    /** TODO: Description */
    blur: <P extends DeepPath<V, P>>(name: P) => void;
    /** TODO: Description */
    push: <P extends DeepPath<V, P>>(name: P, value?: ArrayValue<DeepPathValue<V, P>>) => void;
    /** TODO: Description */
    remove: <P extends DeepPath<V, P>>(name: P, index: number) => void;
};
export declare type unstable_FormInitialState<V> = Partial<Pick<unstable_FormState<V>, "baseId" | "values">> & {
    /** TODO: Description */
    validateOnBlur?: boolean;
    /** TODO: Description */
    validateOnChange?: boolean;
    /** TODO: Description */
    resetOnSubmitSucceed?: boolean;
    /** TODO: Description */
    resetOnUnmount?: boolean;
    /** TODO: Description */
    onValidate?: (values: V) => ValidateReturn<V>;
    /** TODO: Description */
    onSubmit?: (values: V) => ValidateReturn<V>;
};
export declare type unstable_FormStateReturn<V> = unstable_FormState<V> & unstable_FormActions<V>;
export declare function unstable_useFormState<V = Record<any, any>>(initialState?: SealedInitialState<unstable_FormInitialState<V>>): unstable_FormStateReturn<V>;
export declare namespace unstable_useFormState {
    var __keys: ("push" | "values" | "remove" | "blur" | "submit" | "reset" | "baseId" | "touched" | "messages" | "errors" | "validating" | "valid" | "submitting" | "submitSucceed" | "submitFailed" | "validate" | "update")[];
}
export {};
