import { SealedInitialState } from "../__utils/useSealedState";
export declare type HiddenState = {
    /**
     * Hidden element id.
     */
    unstable_hiddenId: string;
    /**
     * Whether it's visible or not.
     * @default false
     */
    visible: boolean;
};
export declare type HiddenActions = {
    /**
     * Changes the `visible` state to `true`
     */
    show: () => void;
    /**
     * Changes the `visible` state to `false`
     */
    hide: () => void;
    /**
     * Toggles the `visible` state
     */
    toggle: () => void;
};
export declare type HiddenInitialState = Partial<Pick<HiddenState, "unstable_hiddenId" | "visible">>;
export declare type HiddenStateReturn = HiddenState & HiddenActions;
export declare function useHiddenState(initialState?: SealedInitialState<HiddenInitialState>): HiddenStateReturn;
export declare namespace useHiddenState {
    var __keys: ("show" | "hide" | "unstable_hiddenId" | "visible" | "toggle")[];
}
