import * as React from "react";
import { RoverOptions, RoverProps } from "../Rover/Rover";
import { RadioStateReturn } from "./RadioState";
export declare type RadioOptions = RoverOptions & Partial<RadioStateReturn> & {
    /**
     * Same as the `value` attribute.
     */
    value: any;
    /**
     * Same as the `checked` attribute.
     */
    checked?: boolean;
};
export declare type RadioProps = RoverProps & React.InputHTMLAttributes<any>;
export declare function useRadio(options: RadioOptions, htmlProps?: RadioProps): RadioProps;
export declare namespace useRadio {
    var __keys: ("unstable_system" | "orientation" | "unstable_stops" | "unstable_currentId" | "unstable_pastId" | "unstable_loop" | "unstable_register" | "unstable_unregister" | "unstable_move" | "unstable_next" | "unstable_previous" | "unstable_first" | "unstable_last" | "unstable_reset" | "unstable_orientate" | "disabled" | "unstable_focusable" | "unstable_clickKeys" | "stopId" | "value" | "currentValue" | "setValue" | "checked")[];
}
export declare const Radio: <TT extends React.ElementType<any> = "input">({ as, ...props }: import("../__utils/types").PropsWithAs<RadioOptions, TT>, ref: React.Ref<any>) => JSX.Element;
