import * as React from "react";
import { SealedInitialState } from "../__utils/useSealedState";
import { RoverState, RoverActions, RoverInitialState } from "../Rover";
export declare type RadioState = RoverState & {
    /**
     * The `value` attribute of the current checked radio.
     */
    currentValue: any;
};
export declare type RadioActions = RoverActions & {
    /**
     * Changes the `currentValue` state.
     */
    setValue: React.Dispatch<React.SetStateAction<any>>;
};
export declare type RadioInitialState = RoverInitialState & Partial<Pick<RadioState, "currentValue">>;
export declare type RadioStateReturn = RadioState & RadioActions;
export declare function useRadioState(initialState?: SealedInitialState<RadioInitialState>): RadioStateReturn;
export declare namespace useRadioState {
    var __keys: ("orientation" | "unstable_stops" | "unstable_currentId" | "unstable_pastId" | "unstable_loop" | "unstable_register" | "unstable_unregister" | "unstable_move" | "unstable_next" | "unstable_previous" | "unstable_first" | "unstable_last" | "unstable_reset" | "unstable_orientate" | "currentValue" | "setValue")[];
}
