/// <reference types="react" />
import { BoxOptions, BoxProps } from "../Box/Box";
export declare type SeparatorOptions = BoxOptions & {
    /**
     * Separator's context orientation.
     * The actual separator's oriention will be flipped based on this prop.
     * So a `"vertical"` orientation means that the separator will have a
     * `"horizontal"` orientation.
     */
    orientation?: "horizontal" | "vertical";
};
export declare type SeparatorProps = BoxProps;
export declare function useSeparator({ orientation, ...options }?: SeparatorOptions, htmlProps?: SeparatorProps): import("react").HTMLAttributes<any> & import("react").RefAttributes<any>;
export declare namespace useSeparator {
    var __keys: ("unstable_system" | "orientation")[];
}
export declare const Separator: <TT extends import("react").ElementType<any> = "hr">({ as, ...props }: import("../__utils/types").PropsWithAs<SeparatorOptions, TT>, ref: import("react").Ref<any>) => JSX.Element;
